function saveQueueForm(formObj)
{
	if(!validateName(formObj.name.value))
	{
		alert($i18n("fcm.sq.queue.js.saveQueueForm.alert0.txt"));
		formObj.name.select();
		formObj.name.focus();
		return false;
	}

	if(!validateDescription(formObj.description.value))
	{
		alert($i18n("fcm.sq.queue.js.saveQueueForm.alert1.txt"));
		formObj.description.select();
		formObj.description.focus();
		return false;
	}

	// Inactive/Closed status check
	if(formObj.status[1].checked || formObj.status[3].checked)
	{
		var statusValue = (formObj.status[1].checked) ? formObj.status[1].nextSibling.nodeValue : formObj.status[3].nextSibling.nodeValue
		statusValue = statusValue.replace(/\W+$/,"");// remove &nbsp; from end of text node.
		if(!confirm($i18n("fcm.sq.queue.js.saveQueueForm.confirm0.0.txt",[statusValue])+"\n\n"+
			    $i18n("fcm.sq.queue.js.saveQueueForm.confirm0.1.txt")))
		return false;
	}

	if(parseInt(formObj.callLowerBound.value) > parseInt(formObj.callUpperBound.value))
	{
	alert($i18n("fcm.sq.queue.js.saveQueueForm.alert2.0.txt")+"\n"+
	      $i18n("fcm.sq.queue.js.saveQueueForm.alert2.1.txt",[formObj.callLowerBound.options[formObj.callLowerBound.selectedIndex].text,formObj.callUpperBound.options[formObj.callUpperBound.selectedIndex].text]));


	formObj.callLowerBound.focus();
	return false;
	}

	var resultSettingArray = ["skip","reschedule","savepending","verifiedactivity","reroute","confirmedfraud"];

	atLeastOnePicked = false;
	for(var i = 0; i < resultSettingArray.length; i++){
		if(document.queueForm.elements["callResult("+resultSettingArray[i]+")"].checked){
			atLeastOnePicked = true;
		}
	}
	if(!atLeastOnePicked)
	{
		alert($i18n("fcm.sq.queue.js.saveQueueForm.alert3.txt"));
		return false;
	}

	if(!validateCallResultSettings(document.queueForm,["skip","reschedule","savepending","savependingblock","reroute","verifiedactivity","confirmedfraud"]))
		return false;


	if(isDefined(formObj.autoCloseNewAlert)){
		var days = parseInt(formObj.autoCloseNewAlert.value);
		if(isNaN(formObj.autoCloseNewAlert.value) || days != parseFloat(formObj.autoCloseNewAlert.value))
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert4.txt"));
			formObj.autoCloseNewAlert.focus();
			formObj.autoCloseNewAlert.select();
			return false;
		}
		if(days < 0 || days > 360)
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert5.txt"));
			formObj.autoCloseNewAlert.focus();
			formObj.autoCloseNewAlert.select();
			return false;
		}
	}
	if(isDefined(formObj.systemBlockDays)){
		var days = parseInt(formObj.systemBlockDays.value);
		if(isNaN(formObj.systemBlockDays.value) || days != parseFloat(formObj.systemBlockDays.value))
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert6.txt"));
			formObj.systemBlockDays.focus();
			formObj.systemBlockDays.select();
			return false;
		}
		if(days < 0 || days > 360)
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert7.txt"));
			formObj.systemBlockDays.focus();
			formObj.systemBlockDays.select();
			return false;
		}
	}
	if(isDefined(formObj.transactionBlockDays)){
		var days = parseInt(formObj.transactionBlockDays.value);
		if(isNaN(formObj.transactionBlockDays.value) || days != parseFloat(formObj.transactionBlockDays.value))
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert8.txt"));
			formObj.transactionBlockDays.focus();
			formObj.transactionBlockDays.select();
			return false;
		}
		if(days < 0 || days > 360)
		{
			alert($i18n("fcm.sq.queue.js.saveQueueForm.alert9.txt"));
			formObj.transactionBlockDays.focus();
			formObj.transactionBlockDays.select();
			return false;
		}
	}
	//High Risk Combo
	if(isDefined(document.getElementById("comboListbox"))){
		if(document.getElementById("comboListbox").options.length>0){
			if(isDefined(formObj.warningMsg)){
				if(formObj.warningMsg.value==""){
					alert($i18n("fcm.sq.queue.js.saveQueueForm.alert10.txt"));
					formObj.warningMsg.focus();
					formObj.warningMsg.select();
					return false;
				}
			}
		}
	}

	//getElement("saveButton").disabled = true;

	for(var i = 0; i < _itemPriorityList.length; i++)
	{
		obj = _itemPriorityList[i];
		// don't pass loaded queue in
		if(obj.priority != obj.newPriority)
	{
	// Queue New Priority
	ele = document.createElement("input");
	ele.type = "hidden";
	ele.name = "newQueuePriority("+obj.id+")";
	ele.value = ""+obj.newPriority+":"+obj.version;
	formObj.appendChild(ele);

		}
	}

	// pass the disabled checkbox to form
	if(formObj.elements["callResult(confirmedfraud)"].checked)
	{
		formObj.elements["neverReschedule(confirmedfraud)"].disabled = false;
	}
	comboListAssignment();
	postAssignment(emailList,'emailsStr');
	postAssignment(letterList,'lettersStr');
	postAssignment(smsList,'smssStr');

	formObj.callSuperseded.value = (formObj.callSupersededCheckbox.checked?"0":"1");
	formObj.stickyQueue.value = (formObj.stickyQueueCheckbox.checked?"1":"0");
	formObj.method.value="save";

	postPosCodes();
	postFraudTypes();
	postAllowRerouteTo();
	postSystemBlocks();
	postTransactionBlocks();

	setBusy();
}

function postAssignment(arrayList,eleName)
{
	var assignedElement = document.createElement("input");
	assignedElement.type = "hidden";
	assignedElement.name = eleName;
	assignedElement.value = "";

	for(var i = 0, len = arrayList.length; i < len; i++)
	{
		var item = arrayList[i];
		if(item.isAssigned)
	{
	assignedElement.value += item.id+":";
}

}

	if(assignedElement.value.length > 0)
		document.queueForm.appendChild(assignedElement);

}

function initCallResultSetting(callResult,formObj)
{


	var resultSetting = callResults[callResult.toUpperCase()];


	if(isDefined(resultSetting) && isDefined(formObj))
	{

		formObj.elements["callResultId("+callResult+")"].value = resultSetting.id;
		formObj.elements["callResultName("+callResult+")"].value = resultSetting.name;
		if(resultSetting.blockApplied != null)
		{
			formObj.elements["blockApplied("+callResult+")"].value = resultSetting.blockApplied;
		}

		if(resultSetting.isAssigned)
		{
			formObj.elements["callResult("+callResult+")"].click();

			/* Reschedule in Minutes */
			if(isDefined(resultSetting.minutes)){
				//formObj.elements["minutes("+callResult+")"].checked = true;
				formObj.elements["minutes("+callResult+")"].click();
				if(resultSetting.minutes > 59){
					formObj.elements["minutesValue("+callResult+")"].value = resultSetting.minutes/60;
					formObj.elements["minutesUnit("+callResult+")"].selectedIndex = 1; // hours
				}
				else{
					formObj.elements["minutesValue("+callResult+")"].value = resultSetting.minutes;
					formObj.elements["minutesUnit("+callResult+")"].selectedIndex = 0; // minutes
				}
			}
			if(resultSetting.systemBlocksAssigned){
				formObj.elements["applySystemBlock("+callResult+")"].click();
			}
			if(isDefined(resultSetting.removeSystemBlock)){
				formObj.elements["removeSystemBlock("+callResult+")"].checked=resultSetting.removeSystemBlock;
			}

			if(resultSetting.transactionBlocksAssigned){
				formObj.elements["applyTransactionBlock("+callResult+")"].click();
			}
			if(isDefined(resultSetting.removeTransactionBlock)){
				formObj.elements["removeTransactionBlock("+callResult+")"].checked=resultSetting.removeTransactionBlock;
			}

			if(callResult=='REROUTE'){
				if(isDefined(resultSetting.rerouteAllowRerouteTo)){
					document.getElementById("rerouteAllowRerouteTo").style.display='inline';
				}
			}
			if(callResult=='CONFIRMEDFRAUD'){
				if(isDefined(resultSetting.confirmedfraudFraudTypes)){
					document.getElementById("confirmedfraudFraudTypes").style.display='inline';
				}
			}


			/* Display the "Bring Back when" options */
			if(isDefined(resultSetting.scoreIncrease) ||
				isDefined(resultSetting.score) ||
				isDefined(resultSetting.amount) ||
				isDefined(resultSetting.merchantCountryCodes) ||
					//NEW BBW
				isDefined(resultSetting.notMerchantCountryCodes) ||
				isDefined(resultSetting.sicCodes) ||
				isDefined(resultSetting.notSicCodes)||
				resultSetting.ardEnabled||
				resultSetting.posEnabled
			)
			{
				formObj.elements["whenOptions("+callResult+")"].click();
			}

			/* Reschedule on Score Increase */
			if(isDefined(resultSetting.scoreIncrease)){
				formObj.elements["scoreIncrease("+callResult+")"].click();
				formObj.elements["scoreIncreaseValue("+callResult+")"].value = resultSetting.scoreIncrease;
			}

			/* Reschedule on Score */
			if(isDefined(resultSetting.score)){
				formObj.elements["score("+callResult+")"].click();
				formObj.elements["scoreValue("+callResult+")"].value = resultSetting.score;
			}

			/* Reschedule on Transaction Amount */
			if(isDefined(resultSetting.amount)){
				formObj.elements["amount("+callResult+")"].click();
				formObj.elements["amountValue("+callResult+")"].value = resultSetting.amount;
			}

			/* Reschedule on Merchant Country Code */
			if(isDefined(resultSetting.merchantCountryCodes)){
				formObj.elements["merchantCountry("+callResult+")"].click();
				formObj.elements["merchantCountryCodesValue("+callResult+")"].value = unescapeXml(resultSetting.merchantCountryCodes);
			}

			/* Reschedule on Merchant Country Code Not*/
			if(isDefined(resultSetting.notMerchantCountryCodes)){
				formObj.elements["merchantCountryNot("+callResult+")"].click();
				formObj.elements["notMerchantCountryCodesValue("+callResult+")"].value = unescapeXml(resultSetting.notMerchantCountryCodes);
			}
			/* Reschedule on SIC*/
			if(isDefined(resultSetting.sicCodes)){
				formObj.elements["sic("+callResult+")"].click();
			  formObj.elements["sicCodesValue("+callResult+")"].value = unescapeXml(resultSetting.sicCodes);
			}
			/* Reschedule on SIC Not*/
			if(isDefined(resultSetting.notSicCodes)){
				formObj.elements["notSic("+callResult+")"].click();
				formObj.elements["notSicCodesValue("+callResult+")"].value = unescapeXml(resultSetting.notSicCodes);
			}
			/*Reschedule on ARD*/

			if(resultSetting.ardEnabled){
				formObj.elements["ard("+callResult+")"].click();
			}
			/*Reschedule on POS*/
			if(resultSetting.posEnabled){
				formObj.elements["pos("+callResult+")"].click();
			}

			/* Reschedule next scheduled day */

			if(resultSetting.rescheduleNextDay){
				formObj.elements["nextDay("+callResult+")"].checked = true;
			}

			/* Never Reschedule */
			if(resultSetting.rescheduleNever){
				formObj.elements["neverReschedule("+callResult+")"].click();
			}

			/* Reschedule by timestamp*/
			if(resultSetting.rescheduleTimestamp){
				formObj.elements["rescheduleTimestamp("+callResult+")"].click();
			}

			/* Auto close setting*/
			if(isDefined(resultSetting.autoClose)){
				formObj.elements["autoClose("+callResult+")"].value = resultSetting.autoClose;
			}

		}

	}

}
function isInteger(chk,ipt)
{

	if(isDefined(chk) && chk.checked)
	{
		var valueStr = ipt.value;
		if(valueStr.length > 0 && valueStr.indexOf('.') < 0 && !isNaN(valueStr))
			return !isNaN(parseInt(valueStr));
		return false;
	}
	return true;
}

function isFloat(chk,ipt)
{
	if(isDefined(chk) && chk.checked)
	{
		var valueStr = ipt.value;
		if(valueStr.length > 0 && !isNaN(valueStr))
			return !isNaN(parseFloat(valueStr));
		return false;
	}
	return true;
}

function validateCallResultSettings(formObj,namesList)
{

	if(!isDefined(formObj))
	{
		alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert0.txt"));
		return false;
	}


	for(var i = 0; i < namesList.length; i++)
	{
		var optionSelected = false;
		var callResult = namesList[i];
		var label = '"'+formObj.elements["callResult("+callResult+")"].parentNode.childNodes[1].nodeValue +'"';
		if(callResult=='savepending'){
			if(formObj.elements["callResult("+callResult+")"].checked)
				formObj.elements["callResult(savependingblock)"].checked=true;
			else formObj.elements["callResult(savependingblock)"].checked=false;
		}

		if(formObj.elements["callResult("+callResult+")"].checked)
		{
//			if(callResult!="confirmedfraud"){
				chk = formObj.elements["minutes("+callResult+")"];
				ipt = formObj.elements["minutesValue("+callResult+")"];
				if(!isInteger(chk,ipt))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert1.txt"));
					ipt.focus();
					ipt.select();
					return false;
				}
				// values between 1 minute and 10 hours
				if(chk && chk.checked)
				{
					optionSelected = true;
					var unit = formObj.elements["minutesUnit("+callResult+")"];
					var unitValue = unit.options[unit.selectedIndex].value;

					if(unitValue == 'min' && parseInt(ipt.value) < 1) // data entry limited to two digits
					{
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert2.txt"));
						ipt.focus();
						ipt.select();
						return false;
					}
					else if(unitValue == 'hr' && (parseInt(ipt.value) < 1 || parseInt(ipt.value) > 10))
					{
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert3.txt"));
						ipt.focus();
						ipt.select();
						return false;
					}
				}


				if(isDefined(formObj.elements["autoClose("+callResult+")"])){
					chk =formObj.elements["callResult("+callResult+")"];
					ipt = formObj.elements["autoClose("+callResult+")"];
					if(!isInteger(chk,ipt))
					{
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert4.txt"));
						ipt.focus();
						ipt.select();
						return false;
					}

					if(chk && chk.checked) // only allow values between 0 and 360
					{
						var days = parseInt(ipt.value);
						if(days < 0 || days > 360)
						{
							alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert5.txt"));
							ipt.focus();
							ipt.select();
							return false;
						}
					}
				}

				chk = formObj.elements["nextDay("+callResult+")"];
				if(chk && chk.checked) optionSelected = true;

				chk = formObj.elements["rescheduleTimestamp("+callResult+")"];
				if(chk && chk.checked) optionSelected = true;

				chk = formObj.elements["neverReschedule("+callResult+")"];
				if(chk && chk.checked) optionSelected = true;

				//BLOCKS
				chk = formObj.elements["applySystemBlock("+callResult+")"];
				chk = formObj.elements["removeSystemBlock("+callResult+")"];
				if(callResult=='savependingblock'){
					formObj.elements["removeSystemBlock(savepending)"].checked=chk.checked;
				}
				chk = formObj.elements["applyTransactionBlock("+callResult+")"];
				if(callResult=='savependingblock'){
					formObj.elements["applyTransactionBlock(savepending)"].checked=chk.checked;
				}
				chk = formObj.elements["removeTransactionBlock("+callResult+")"];
				if(callResult=='savependingblock'){
					formObj.elements["removeTransactionBlock(savepending)"].checked=chk.checked;
				}


				//NEW BBW

				var bbwOptSelected=false;
				chk = formObj.elements["scoreIncrease("+callResult+")"];
				ipt = formObj.elements["scoreIncreaseValue("+callResult+")"];
				if(chk && chk.checked) bbwOptSelected = true;
				if(!isInteger(chk,ipt))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert6.txt"));
					ipt.focus();
					ipt.select();
					return false;
				}

				chk = formObj.elements["score("+callResult+")"];
				ipt = formObj.elements["scoreValue("+callResult+")"];
				if(chk && chk.checked) bbwOptSelected = true;
				if(!isInteger(chk,ipt))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert7.txt"));
					ipt.focus();
					ipt.select();
					return false;
				}

				chk = formObj.elements["amount("+callResult+")"];
				ipt = formObj.elements["amountValue("+callResult+")"];
				if(chk && chk.checked) bbwOptSelected = true;
				if(!isFloat(chk,ipt))
				{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert8.txt"));
					ipt.focus();
					ipt.select();
					return false;
				}
				chk = formObj.elements["merchantCountry("+callResult+")"];
				if(chk && chk.checked) {
					bbwOptSelected = true;
					ipt=formObj.elements["merchantCountryCodesValue("+callResult+")"];
					if(ipt.value==''){
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert9.txt",[label]));
						ipt.focus();
						ipt.select();
						return false;
					}
					var notChk=formObj.elements["merchantCountryNot("+callResult+")"];
					if(notChk && notChk.checked){
						var notIn=formObj.elements["notMerchantCountryCodesValue("+callResult+")"].value.split(";");
						var both="";
						for(var z=0;z<notIn.length;z++){
							if(notIn!=''){
							if(ipt.value.indexOf(notIn[z])>-1){
								both+=notIn[z] + "\n\t ";
							}
						}
					}
					if(both!=""){
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert10.0.txt")+"\r\t"+
						      $i18n("fcm.sq.queue.js.validateCallResultSettings.alert10.1.txt",[both])+"\r"+
						      $i18n("fcm.sq.queue.js.validateCallResultSettings.alert10.2.txt"));
						ipt.focus();
						ipt.select();
						return false;
					}
				}
			}

			chk = formObj.elements["merchantCountryNot("+callResult+")"];
			if(chk && chk.checked) {
				bbwOptSelected = true;
				ipt=formObj.elements["notMerchantCountryCodesValue("+callResult+")"];
				if(ipt.value==''){
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert11.txt",[label]));
					ipt.focus();
					ipt.select();
					return false;
				}
			}

			chk = formObj.elements["sic("+callResult+")"];
			if(chk && chk.checked) {
				bbwOptSelected= true;
				ipt=formObj.elements["sicCodesValue("+callResult+")"];
				if(ipt.value==''){
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert12.txt",[label]));
					ipt.focus();
					ipt.select();
					return false;
				}
				var notChk=formObj.elements["notSic("+callResult+")"];
				if(notChk && notChk.checked){
					var notIn=formObj.elements["notSicCodesValue("+callResult+")"].value.split(";");
					var both="";
					for(var z=0;z<notIn.length;z++){
						if(notIn!=''){
							if(ipt.value.indexOf(notIn[z])>-1){
								both+=notIn[z] + "\n\t ";
							}
						}
					}
					if(both!=""){
						alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert13.0.txt")+"\r\t"+
						$i18n("fcm.sq.queue.js.validateCallResultSettings.alert13.1.txt",[both])+"\r"+
						$i18n("fcm.sq.queue.js.validateCallResultSettings.alert13.2.txt"));
						ipt.focus();
						ipt.select();
						return false;
					}
				}
			}

			chk = formObj.elements["notSic("+callResult+")"];
			if(chk && chk.checked) {
				bbwOptSelected = true;
				ipt=formObj.elements["notSicCodesValue("+callResult+")"];
				if(ipt.value==''){
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert14.txt",[label]));
					ipt.focus();
					ipt.select();
					return false;
				}
			}

			chk = formObj.elements["ard("+callResult+")"];
			if(chk && chk.checked) {
				bbwOptSelected = true;
				var ardSelected=false;
				var obj=formObj.elements["ardCodesValue("+callResult+")"];
				for (var j=0; j<obj.length; j++){
					if (obj[j].checked)
						ardSelected=true;
				}
				if(!ardSelected){
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert15.txt",[label]));
					return false;
				}
			}
			if(chk && !chk.checked){
				var obj=formObj.elements["ardCodesValue("+callResult+")"];
				for (var j=0; j<obj.length; j++){
					obj[j].checked=false;
				}
			}

			chk = formObj.elements["pos("+callResult+")"];
			if(chk && chk.checked) {
				bbwOptSelected = true;
				var obj=formObj.elements["selectedPosCodes("+callResult+")"].options;
				ipt=formObj.elements["selectedPosCodes("+callResult+")"];
				if(!obj.length>0) {
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert16.txt",[label]));
					ipt.focus();
					return false;
				}
			 }

			chk = formObj.elements["whenOptions("+callResult+")"];
			if (chk && chk.checked){
				if(!bbwOptSelected){
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert17.txt",[label]));
					formObj.elements["whenOptions("+callResult+")"].focus();
					return false;
				}
			}

			if(bbwOptSelected) optionSelected=true;
			// make sure
			if(!optionSelected)
			{
				if(callResult=='savepending' || callResult=='savependingblock'){
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert18.txt"));
					formObj.elements["callResult(savepending)"].focus();
					return false;
				}
				else{
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert19.txt",[label]));
					formObj.elements["callResult("+callResult+")"].focus();
					return false;
				}
			}

//			}// if call result is not confirmed fraud


			chk = formObj.elements["applyTransactionBlock("+callResult+")"];
			if(chk && chk.checked) {
				var applyTransactionBlockSelected=false;
				var obj=formObj.elements["selectedTransactionBlocks("+callResult+")"].options;
				ipt=formObj.elements["selectedTransactionBlocks("+callResult+")"];
				if(obj.length>0) {
					applyTransactionBlockSelected=true;
				}
				if(!applyTransactionBlockSelected && callResult!='savepending'){
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert20.txt",[label]));
					ipt.focus();
					return false;
				}
			}
			chk = formObj.elements["applySystemBlock("+callResult+")"];
			if(chk && chk.checked) {
				var applySystemBlockSelected=false;
				var obj=formObj.elements["selectedSystemBlocks("+callResult+")"].options;
				ipt=formObj.elements["selectedSystemBlocks("+callResult+")"];
				if(obj.length>0) {
					applySystemBlockSelected=true;
				}
				if(!applySystemBlockSelected  && callResult!='savepending'){
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert21.txt",[label]));
					ipt.focus();
					return false;
				}
			}

			if(callResult=='reroute'){
				var obj=formObj.elements["selectedAllowRerouteTo("+callResult+")"].options;
				ipt=formObj.elements["selectedAllowRerouteTo("+callResult+")"];
				if(!obj.length>0) {
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert22.txt",[label]));
					ipt.focus();
					return false;
				}
			}
			if(callResult=='confirmedfraud'){
				var obj=formObj.elements["selectedFraudTypes("+callResult+")"].options;
				ipt=formObj.elements["selectedFraudTypes("+callResult+")"];
				if(!obj.length>0) {
					alert($i18n("fcm.sq.queue.js.validateCallResultSettings.alert23.txt",[label]));
					ipt.focus();
					return false;
				}
			}
		}//if call result is checked

	}//end forloop

	return true;
}




function toggleConfiguration(chkbx,linkName, divName)
{
	if(chkbx.checked)
	{
		hideDiv(linkName);
		showDiv(divName);
	}
	else
	{
		showDiv(linkName);
		hideDiv(divName);
	}
}

function disableCallResultOptions(prefix,isDisabled)
{
	elms = document.queueForm.elements;

	for(var i = 0; i < elms.length; i++)
	{
		if(isDefined(elms[i].id) && elms[i].id.indexOf(prefix) == 0)
		{
			elms[i].disabled = isDisabled;
		}

	}

}

function enableElements(resultName,elemNameList,isDisabled)
{

	for(var i = 0; i < elemNameList.length; i++)
	{
		var elem = document.queueForm.elements[elemNameList[i]+"("+resultName+")"];

		if(isDefined(elem))
		{
			if(elem.checked) elem.click();
			if(isDefined(isDisabled)){
				elem.disabled = isDisabled;

			}
		}

	}

}

function setStickySetting(chkbx,stickyChkbx)
{
	if(chkbx.checked)
	{
		stickyChkbx.checked = true;
		stickyChkbx.disabled = true;
	}
	else
	{
		stickyChkbx.disabled = false;
	}
}

function activate(chkbox,txtFldName)
{
	txtFld = document.queueForm[txtFldName];

	txtFld.disabled = !chkbox.checked;
	txtFld.disabled == true ? txtFld.blur() : txtFld.focus();

}
function showQueuePriorityList()
{
	doHide(document.queueForm.callLowerBound)
	doHide(document.queueForm.callUpperBound);
	doHide(document.queueForm.sortField);
	doHide(document.queueForm.sortOrder);
//	doHide(document.queueForm.queueTypeCode);

	var aTag = getElement('queueRelativePriority')
	var srcRowIndex = parseInt(aTag.innerHTML);
	var tableRef = getElement('queuePriorityTable');
	var qpList = getElement('queuePriorityList');
	qpList.style.top = getTopPosition(aTag);
	qpList.style.left = getLeftPosition(aTag);
	//showDiv('queuePriorityList');
    element = getElement('queuePriorityList');
    element.style.display = "block";

	for(var i = 0,scrollTop = 0; i < srcRowIndex-2; i++)
	{
		scrollTop += tableRef.rows[i].offsetHeight;
	}
	qpList.scrollTop = scrollTop;
}

function setQueuePriority(rowRef)
{

	srcRowIndex = parseInt(getElement('queueRelativePriority').innerHTML) - 1;
	tgtRowIndex = rowRef.rowIndex - 1;

	tableRef = getElement('queuePriorityTableBody');
	if(srcRowIndex != tgtRowIndex)
	{
		newRow = moveRow(tableRef,srcRowIndex,tgtRowIndex);
		swapItemPriority(srcRowIndex,tgtRowIndex);
		swapItemLocation(srcRowIndex, tgtRowIndex);
		highlightRow(newRow,'rowSelected');

		// reset relative priorities value for all rows
		numRows = tableRef.getElementsByTagName("TR").length;
		for(i = 0; i < numRows; i++)
		{
			tableRef.rows[i].cells[0].innerHTML = (i+1);
		}
	}

	getElement('queueRelativePriority').innerHTML=(tgtRowIndex+1)+" ";
	hideQueuePriorityList();
}

function hideQueuePriorityList()
{
	doShow(document.queueForm.callLowerBound)
	doShow(document.queueForm.callUpperBound);
	doShow(document.queueForm.sortField);
	doShow(document.queueForm.sortOrder);
	hideDiv('queuePriorityList');
}



function enableDivElements(resultName,elemNameList, on)
{

	toggleDiv(resultName+'WhenOptionsDiv',on);

	enableElements(resultName,elemNameList,on);

}
var _emailType = 0;
var _letterType = 1;
var _smsType = 2;
var _defaultTemplateIds = ["-101","-101","-101"];

function populateDefaultFields(templateType, defaultItem){


	//CHANGE THE COLOR OF THE OPTION TO INDICATE IT IS DEFAULT
	defaultItem.className = "defaultTemplateItem";

	if(templateType==0){
		var arrayList = emailList;
		var item = arrayList[defaultItem.value];
		if(item.isAssigned)
		document.queueForm.defaultEmail.value=item.id;
		$('#defaultEmailDisplay').text(defaultItem.text);

	}
	else if(templateType==1){
		var arrayList = letterList;
		var item = arrayList[defaultItem.value];
		document.queueForm.defaultLetter.value=item.id;
		$('#defaultLetterDisplay').text(defaultItem.text);

	}
	else if(templateType==2){
		var arrayList = smsList;
		var item = arrayList[defaultItem.value];
		document.queueForm.defaultSms.value=item.id;
		$('#defaultSmsDisplay').text(defaultItem.text);
	}
}

function setAsDefaultItem(evt, listBoxName)
{
	//DETERMINE THE TEMPLATE TYPE
	if (listBoxName.indexOf("Emails")>0) var templateType=_emailType;
	else if (listBoxName.indexOf("Letters")>0) var templateType=_letterType;
	else var templateType=_smsType;

	//DETERMINE WHICH LISTBOX IS MAKING THE CALL
	var caller = document.getElementsByName(listBoxName)[0];
	//IF NO SELECTIONS ARE MADE RETURN
	if(caller.selectedIndex == -1) return;

	for(var i = 0; i < caller.options.length; i++)
	{
		//DETERMINE THE POSITION OF THE OPTION
		var defaultItem = caller.options[i];
		//IF OPTION IS THE SELECTED OPTION
		if(i == caller.selectedIndex)
		{
			//POPULATE _defaultTemplateIds[templateType] WITH THE POSITION OF THE SELECTED OPTION
			_defaultTemplateIds[templateType] = defaultItem.value;

			//POPULATE THE HIDDEN FIELD defaultEmail with the templateId-THIS WILL BE SAVED IN THE queueForm
			//DISPLAY THE DEFAULT TEMPLATE WITH THE TEMPLATE NAME
			populateDefaultFields(templateType, defaultItem);

		}
		//TURN THE PREVIOUS DEFAULT TO REGULAR COLOR
		else if(defaultItem.className == "defaultTemplateItem")
		{
			defaultItem.className = "";

		}
	}
	//DESELECT ALL OPTIONS
	caller.selectedIndex = -1;
}

//CALLED WHEN A USER ASSIGNS NEW TEMPLATES OR REMOVES TEMPLATES
function selectDefaultItem(evt,listBoxName)
{

	//DETERMINE THE TEMPLATE TYPE
	if (listBoxName.indexOf("Emails")>0) var templateType=_emailType;
	else if (listBoxName.indexOf("Letters")>0) var templateType=_letterType;
	else var templateType=_smsType;

	//DETERMINE WHICH LISTBOX IS MAKING THE CALL
	var caller = document.getElementsByName(listBoxName)[0];
	//INITIALIZE EXISTS FLAG TO FALSE
	var exists = false;

	//LOOP THROUGH ALL THE LISTBOX OPTIONS
	for(var i = 0; i < caller.options.length; i++)
	{
		var defaultItem = caller.options[i];
		var len=caller.options.length;
		defaultItem.className=="";

		//IF WE HAD ALREADY SAVED A DEFAULT
		//OR
		//IF THE POSITION OF THE CURRENT OPTION IS THE SAME AS THE PREVIOUS DEFAULT TEMPLATE
		if(defaultItem.value == _defaultTemplateIds[templateType] ){

			//alert("THE PREVIOUS DEFAULT TEMPLATE STILL EXISTS: " + defaultItem.value);

			//CHANGE THE THE DEFAULT FIELDS
			populateDefaultFields(templateType, defaultItem);

			//SET THE EXIST VALUE TO TRUE
			exists = true;
		}
		if(!exists && _defaultTemplateIds[templateType]>=0){//THE PREVIOUS DEFAULT TEMPLATE HAS BEEN REMOVED
			if(_defaultTemplateIds[templateType]<defaultItem.value || i==len-1){
				//alert("THE DEFAULT DOES NOT EXIST ANYMORE.  TAKE THE OPTION THAT WAS IN THE PREVIOUS DEFAULTS POSITION OR IF IT DOESN'T EXIST TAKE THE LAST ONE: " + defaultItem.value);

				_defaultTemplateIds[templateType]=defaultItem.value;

				//SET NEW DEFAULT VALUES
				populateDefaultFields(templateType, defaultItem);

				//STOP LOOPING
				break;
			}
		}
	}
	if(!exists){//NO PREVIOUS DEFAULT OR NO OPTIONS IN LISTBOX

		if (len>0){//THERE ARE OPTIONS IN THE LISTBOX
			//NO PREVIOUS DEFAULT TEMPLATE, SO WE SET DEFAULT TO THE FIRST OPTION ON THE LIST
			if(_defaultTemplateIds[templateType]<0){
				//alert("THERE WAS NO PREVIOUS DEFAULT TEMPLATE SO WE SET IT TO THE FIRST ONE ON THE LIST");
				var defaultItem=caller.options[0];
				_defaultTemplateIds[templateType] = defaultItem.value;
				populateDefaultFields(templateType,defaultItem);
			}


		}
		else{//THERE ARE NO OPTIONS IN THE LISTBOX
			//alert("THERE ARE NO OPTIONS IN THE LISTBOX");
			_defaultTemplateIds[templateType]="-101";
			if(templateType==0){
				document.queueForm.defaultEmail.value="";
				document.getElementById('defaultEmailDisplay').innerHTML ="";
			}
			if(templateType==1){
				document.queueForm.defaultLetter.value="";
				document.getElementById('defaultLetterDisplay').innerHTML ="";
			}
			if(templateType==2){
				document.queueForm.defaultSms.value="";
				document.getElementById('defaultSmsDisplay').innerHTML ="";
			}

		}
	}
}



/****NEW BBW***/

//maximum number of allowed checked boxes
var maxChecks=4;

function limitSelections(obj){

	var checkCount=0;

	if(obj.name.match("skip")!=null) checkCount=SKIPCount;
	if(obj.name.match("reschedule")!=null) checkCount=RESCHEDULECount;
	if(obj.name.match("savependingblock")!=null) checkCount=SAVEPENDINGBLOCKCount;
	else if(obj.name.match("savepending")!=null)checkCount=SAVEPENDINGCount;
	if(obj.name.match("reroute")!=null) checkCount=REROUTECount;
	if(obj.name.match("verified")!=null) checkCount=VERIFIEDACTIVITYCount;
	if(obj.name.match("confirmed")!=null) checkCount=CONFIRMEDFRAUDCount;

	if(obj.checked){
		checkCount=checkCount+1;
	}else{
		checkCount=checkCount-1;
	}
	//if they checked a 5th box, uncheck the box, then decrement checkcount and pop alert
	if (checkCount>maxChecks){
		obj.checked=false;
		checkCount=checkCount-1;
		alert($i18n("fcm.sq.queue.js.limitSelections.alert0.txt",[maxChecks]));
	}

	if(obj.name.match("skip")!=null) SKIPCount=checkCount;
	if(obj.name.match("reschedule")!=null) RESCHEDULECount=checkCount;
	if(obj.name.match("savependingblock")!=null) SAVEPENDINGBLOCKCount=checkCount;
	else if(obj.name.match("savepending")!=null) SAVEPENDINGCount=checkCount;
	if(obj.name.match("reroute")!=null) REROUTECount=checkCount;
	if(obj.name.match("verified")!=null) VERIFIEDACTIVITYCount=checkCount;
	if(obj.name.match("confirmed")!=null) CONFIRMEDFRAUDCount=checkCount;
}


function populateText(){

	var selValues='';
	var cntr=0;
	var existingValues=document.getElementById(_name).value;
	var existingValuesArray = existingValues.split(" ; ");
	if(existingValues!='') cntr=existingValuesArray.length;


	var obj=document.getElementById("selMerchantCountry");

	for (var i=0;i<obj.options.length;i++){
			if(obj.options[i].selected==true){
				cntr++;
				if(cntr<11){
					if(selValues!='') selValues=selValues+" ; "+obj.options[i].value;
					else {
						if(existingValues!='') existingValues=existingValues+" ; ";
						selValues=obj.options[i].value;
					}
				}
				else{
					alert($i18n("fcm.sq.queue.js.populateText.alert0.txt"));
					return false;
				}
				obj.options[i].selected=false;
			}
	}

	document.getElementById(_name).value=existingValues+selValues;
	document.getElementById(_name).focus();
}

var _name="";

function maxSel(form, max){
	var ctr = 0;
	for (var i=0; i<form.options.length; i++)
	{
		if (form.options[i].selected==true)
			ctr++;
			if(ctr>max){
				form.options[i].selected=false;
			}
	}

	if (ctr>max)
	{
		alert($i18n("fcm.sq.queue.js.maxSel.alert0.txt",[max]));
		return false;
	}

	return true;
}

function showHideBlock(divName,callResult){
	if(document.getElementById(divName).style.display=='none') {
		document.getElementById(divName).style.display='inline';
	}
	else {
		document.getElementById(divName).style.display='none';

//		if(divName.match("Transaction")!=null){
//			moveAllOptions(document.queueForm.elements['selectedTransactionBlocks('+callResult+')'],document.queueForm.elements['availableTransactionBlocks('+callResult+')'],false, callResult+"TransactionBlocks");
//		}
//		if(divName.match("System")!=null){
//			moveAllOptions(document.queueForm.elements['selectedSystemBlocks('+callResult+')'],document.queueForm.elements['availableSystemBlocks('+callResult+')'],false, callResult+"SystemBlocks");
//		}
//		if(divName.match("Pos")!=null){
//			moveAllOptions(document.queueForm.elements['selectedPosCodes('+callResult+')'],document.queueForm.elements['availablePosCodes('+callResult+')'],false, posCodesByCallResult[callResult]);
//		}
//		if(divName.match("AllowRerouteTo")!=null){
//			moveAllOptions(document.queueForm.elements['selectedAllowRerouteTo('+callResult+')'],document.queueForm.elements['availableAllowRerouteTo('+callResult+')'],false, allowRerouteTo);
//		}
//		if(divName.match("FraudTypes")!=null){
//			moveAllOptions(document.queueForm.elements['selectedFraudTypes('+callResult+')'],document.queueForm.elements['availableFraudTypes('+callResult+')'],false, fraudTypes);
//		}

	}
}


/***********************************************
* Drop Down/ Overlapping Content-  Dynamic Drive (www.dynamicdrive.com)
* This notice must stay intact for legal use.
* Visit http://www.dynamicdrive.com/ for full source code
***********************************************/

function getposOffset(overlay, offsettype){
	var totaloffset=(offsettype=="left")? overlay.offsetLeft : overlay.offsetTop;
	var parentEl=overlay.offsetParent;
	while (parentEl!=null){
	totaloffset=(offsettype=="left")? totaloffset+parentEl.offsetLeft : totaloffset+parentEl.offsetTop;
	parentEl=parentEl.offsetParent;
}
return totaloffset;
}

function overlay(curobj, subobjstr, opt_position){


	if(curobj.disabled)return false;

	highlightSelections();

	if (document.getElementById){
		var subobj=document.getElementById(subobjstr)
		subobj.style.display=(subobj.style.display!="block")? "block" : "none"
		var xpos=getposOffset(curobj, "left")+((typeof opt_position!="undefined" && opt_position.indexOf("right")!=-1)? -(subobj.offsetWidth-curobj.offsetWidth) : 0)
		var ypos=getposOffset(curobj, "top")+((typeof opt_position!="undefined" && opt_position.indexOf("bottom")!=-1)? curobj.offsetHeight : 0)
		subobj.style.left=xpos+"px"
		subobj.style.top=ypos+"px"
		return false
	}
	else
		return true
}



function overlayclose(subobj){

	for (var i=0;i<document.queueForm.selMerchantCountry.options.length;i++){
		document.queueForm.selMerchantCountry.options[i].style.color="black";
		document.queueForm.selMerchantCountry.options[i].selected=false;
	}
	document.getElementById(subobj).style.display="none";
}

function processCodeDescription(valid, invalid, obj,notInBothChk) {

	if(!invalid=='') alert($i18n("fcm.sq.queue.js.processCodeDescription.alert0.txt", [invalid]));

	//country and sic codes cannot exist in both in and not in conditions
	if(notInBothChk){
		notInBoth(obj,valid);
 	}

	var validArr=valid.split(";");
	if (validArr.length>10){
		valid='';
		for(var i=0;i<10;i++){
			if(valid=='')valid+=validArr[i];
			else valid+=" ; "+validArr[i];
		}
		alert($i18n("fcm.sq.queue.js.processCodeDescription.alert1.txt"));
	}
	document.queueForm.elements[obj].value=valid;
	document.queueForm.elements[obj].style.color="green";

	window.status = '';

}

function getCodeDescription(obj,type,code,notInBoth) {

	code=RegExp.escape(code);
 	code = code.replace(/['"]/g,"");
	code = code.replace(/[ ,]/g , ";");
	window.status = 'Loading data...';

	try {
		var url = "a_codeDesc.sj?method=getDescription&callingPage=queuePage&type=" + type + "&code=" + code+"&obj="+obj+"&notInBoth="+notInBoth;
		var hiddenIFrame = window.frames['codeLookupFrame'];
		hiddenIFrame.document.location.replace(url);
	}
	catch(e) {
		window.status = 'Error loading data.';
	}
}

function enableLookup(elemName){

	elem=document.getElementById(elemName);
	var isDisabled=!elem.disabled;
	if(isDefined(elem)){
		if(isDefined(isDisabled)){
			elem.disabled=isDisabled;
		}
	}

}

function extractCallResult(obj){

	if(!obj)obj=_name;
	var start=obj.indexOf('(');
	var callResult=obj.substring(start+1);
	var end=callResult.indexOf(')');

	return callResult.substring(0,end);
}
function highlightSelections(){

	var callResult=extractCallResult();

	var selections=document.getElementById('merchantCountryCodesValue('+callResult+')').value;
	var notSelections=document.getElementById('notMerchantCountryCodesValue('+callResult+')').value;
	var sels=selections.split(" ; ");
	for (var i=0;i<document.queueForm.selMerchantCountry.options.length;i++){
		for(var j=0;j<sels.length;j++){
			if(document.queueForm.selMerchantCountry.options[i].value==sels[j]){
				document.queueForm.selMerchantCountry.options[i].style.color="green";
			}
		}
	}
	sels=notSelections.split(" ; ");
	for (var i=0;i<document.queueForm.selMerchantCountry.options.length;i++){
		for(var j=0;j<sels.length;j++){
			if(document.queueForm.selMerchantCountry.options[i].value==sels[j]){
				document.queueForm.selMerchantCountry.options[i].style.color="red";
			}
		}
	}
}


function notInBoth(obj, valid){

	var callResult=extractCallResult(obj);
	var n=obj.replace('('+callResult+')','');
	var allowableLength=3;
	var m;
	if(obj.indexOf('Country')>-1){
		m= (n!='merchantCountryCodesValue') ? "merchantCountryCodesValue" : "notMerchantCountryCodesValue";
	}
	else {
		m= (n!='sicCodesValue') ? "sicCodesValue" : "notSicCodesValue";
		allowableLength=4;
	}
	var mLabel =(m.indexOf('not')>-1) ? "NOT IN" : "IN";
	var rmv = document.getElementById(m+'('+callResult+')').value.toString();
	var rmvArr=valid.split(";");
	var codesInBoth='';

	for(var z=0;z<rmvArr.length;z++){
		if(rmv!='' && trim(rmvArr[z]).length==allowableLength && rmv.indexOf(trim(rmvArr[z].toString()))>-1){
			rmv=rmv.replace(trim(rmvArr[z].toString()),' ');
			if(codesInBoth=='') codesInBoth=trim(rmvArr[z]);
			else codesInBoth+=" ; " + trim(rmvArr[z]) ;
		}
	}

	if(codesInBoth!=''  && document.getElementById(m+'('+callResult+')').disabled==false)
		alert($i18n("fcm.sq.queue.js.notInBoth.alert0.0.txt")+"\n"+
		$i18n("fcm.sq.queue.js.notInBoth.alert0.1.txt",[mLabel])+"\n\n"+
		$i18n("fcm.sq.queue.js.notInBoth.alert0.2.txt",[codesInBoth]));


	rmv=rmv.replace(/[ ;,]/g,'');

	var newRmv='';
	if(rmv.length>=allowableLength){
		var z=0;
		for(var i=allowableLength;i<=rmv.length;i=i+allowableLength){
			if(newRmv=='')newRmv=rmv.substring(z,i);
			else newRmv+=" ; "+rmv.substring(z,i);
			z=z+allowableLength;
		}
	}

	processCodeDescription(newRmv, '', m+'('+callResult+')',false);
	window.status='';

}
function validateCountryCodes(obj,code, notInBothChk){

 	code=RegExp.escape(code);

 	code = code.replace(/['"]/g,"");
	code = code.replace(/[ ,]/g , ";");
	var manyCodes=code.split(";");
	var valid="";
	var invalid="";
	var flag=false;
	var max=manyCodes.length;

	for(var i=0; i<max;i++){
		for(var j=0;j<_countryCodes.length;j++){
			if(trim(manyCodes[i])==_countryCodes[j]){
				flag=true;
				break;
			}
		}
		var re= RegExp(trim(manyCodes[i]));
		if(flag){
			if(!valid.match(re)){
				if(valid=="")valid=trim(manyCodes[i]);
				else valid+=" ; " + trim(manyCodes[i]);
			}
		}
		else{
			if(!invalid.match(re)){
				if(invalid=="")invalid=trim(manyCodes[i]);
				else invalid+= " ; " + trim(manyCodes[i]);
			}
		}
		flag=false;
	}
	processCodeDescription(valid, invalid, obj,notInBothChk);


}
function trim(txt)
{
	if (txt)
		return txt.replace(/^\s+/g, '').replace(/\s+$/g, '');
	else
		return "";
}

RegExp.escape = (function() {
	var specials = ['^','!','@','#','%','&','-','_','=',':','>','<','`','~','$','/', '.', '*', '+', '?', '|','(', ')', '[', ']', '{', '}', '\\' ];

	sRE = new RegExp('(\\' + specials.join('|\\') + ')', 'g');

	return function(text) {
		return text.replace(sRE, '');
	}
})();

function comboListAssignment(){

	var $arrayList=$('#comboListbox option');
	var assignedElement = document.createElement("input");

	assignedElement.type = "hidden";
	assignedElement.name = "warningComboStr";
	assignedElement.id = "warningComboStr";
	assignedElement.value = "";

	$arrayList.each(function(i){
		assignedElement.value += $(this).val()+":";
	});

	if(assignedElement.value.length>0){
		document.queueForm.appendChild(assignedElement);
	}


}
function addComboToListbox(blockCodeSelector,groupCodeSelector,comboListbox){

	var blockCodeValue=$('#blockCodeSelector option:selected').val();
	var groupCodeValue=$('#groupCodeSelector option:selected').val();

	var blockCodeText=$('#blockCodeSelector option:selected').html();
	var groupCodeText=$('#groupCodeSelector option:selected').html();

	if(blockCodeValue=='all' || groupCodeValue =='all'){
			if(blockCodeValue =='all' && groupCodeValue !='all'){

				$('#blockCodeSelector option').each(function(i){
					if(i!=0){
						var comboValue=$(this).val() + "~" +groupCodeValue;
						var comboText=$(this).html() + " & " +groupCodeText;
						addIfDoesntExist(comboListbox,comboValue,comboText);
					}
				});
			}
			else if(blockCodeValue !='all' && groupCodeValue =='all'){
				$('#groupCodeSelector option').each(function(i){
					if(i!=0){
						var comboValue=blockCodeValue + "~" +$(this).val();
						var comboText=blockCodeText + " & " +$(this).html();
						addIfDoesntExist(comboListbox,comboValue,comboText);
					}
				});
			}
			else{
				var $comboListbox = $('#'+comboListbox);
				$comboListbox.find('option').remove();
				var options = [];
				var $blockOptions = $('#blockCodeSelector option:gt(0)');
				var $groupOptions = $('#groupCodeSelector option:gt(0)');
				$blockOptions.each(function(i,blockOption){
					$groupOptions.each(function(j,groupOption){
							var comboValue=$(blockOption).val() + "~" +$(groupOption).val() ;
							var comboText=$(blockOption).html() + " & " +$(groupOption).html();
							options.push('<option value="'+comboValue+'">'+comboText+'</option>');
					});
				});
				$comboListbox.append(options.join(''));
			}
	}
	else{
		var comboValue=blockCodeValue+ "~" +groupCodeValue;
		var comboText=blockCodeText+" & " +groupCodeText;
		addIfDoesntExist(comboListbox,comboValue,comboText);
	}

	if($('#comboListbox option').size()>0)
		document.getElementById("removeCombosAnchor").disabled=false;
}
function addIfDoesntExist(comboListbox,comboValue,comboText){
	var $comboListbox  = $('#'+comboListbox);
	var $option = $comboListbox.find('option[value="'+comboValue+'"]');
	if($option.size() == 0){
		$comboListbox.append('<option value="'+comboValue+'">'+comboText+'</option>');
    }
}


function removeOptions(selectbox)
{
	var $selectbox=$('#'+selectbox);
	$($selectbox).find('option:selected').remove();
	if($selectbox.find('option').size()==0)
		$('#removeCombosAnchor').prop("disabled",true);
}
