<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2006, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/lookupListContents.jsp
|DESCRIPTION: Display pageable contents of a lookup list
|---------------------------------------------------------------------------------------*/%>

<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<HTML>
<HEAD>
    <meta http-equiv="cache-control" content="no-cache"/>
    <TITLE>Rule Tester</TITLE>

    <script language='JavaScript' src='<c:url value="/common/scripts/jquery.js"/>'></script>
    <SCRIPT language='JavaScript' src='<c:url value="/common/scripts/sasSolutions.js"/>'></SCRIPT>
    <SCRIPT language='JavaScript' src='<c:url value="/common/scripts/cf.js"/>'></SCRIPT>
    <SCRIPT language='JavaScript' src='<c:url value="/rules/scripts/ruleSasTest.js"/>'></SCRIPT>
    <SCRIPT language='JavaScript' src='<c:url value="/rules/scripts/lookupLists.js"/>'></SCRIPT>
    <STYLE type='text/css'>@import '<c:url value="/common/styles/sasStyles.css"/>';</style>
    <link rel='stylesheet' href='<c:url value="/common/styles/cf.css"/>' type='text/css'>
    <style type='text/css'>@import '<c:url value="/admin/styles/admin.css"/>';</STYLE>

    <script>
       // List colnames in containing frame (if creating new lookup list)
       function showColumns() {
          var columnTags = parent.document.getElementById('columnTags');
          if (columnTags) {
             var columnNames = new Array();
             var tagText = decodeURIComponent(columnTags.innerHTML); // S1020196
             <c:forTokens var="typedCol" items="${listInfo.typedColumns}" delims="@ ">
                <c:set var='nakedCol' value="${fn:replace(fn:replace(typedCol,'$',''),'#','')}"/>
                var checked = (tagText && tagText!='' && tagText.indexOf('<INPUT')<0 && tagText.indexOf('${typedCol}@')<0) ? " checked='checked'" : ' ';
                columnNames.push("<input type='checkbox' name='COL${typedCol}' id='COL${typedCol}'" + checked + ">${nakedCol}");
             </c:forTokens>
             columnTags.innerHTML = columnNames.join("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
          }
       }
    </script>
</HEAD>


<BODY
    onload="parent.rulesTabFrameResizeHandler();showColumns();"
    onunload=""
    onblur=""
    onmousemove=""
    style="background-color:#FAF8ED; border:1px solid #7F9DB9;border-top:1px solid #FAF8ED;"
    marginheight="0"
    marginwidth="0" >


<%-- Submit the parms that cause the display of the table --%>
<form name="contentsForm" action="<c:url value="/r_lookupLists.do"/>" method="post">
  <input type="hidden" id="method" name="method" value='showLookupListContents'/>
  <input type="hidden" id="engine" name="engine" value="${listInfo.engine}"/>
  <input type="hidden" id="name" name="name" value="${fn:escapeXml(listInfo.name)}"/>
  <input type="hidden" id="inds" name="inds" value="${listInfo.inds}"/>
  <input type="hidden" id="columns" name="columns" value="${listInfo.typedColumns}"/>
  <input type="hidden" id="totalRows" name="totalRows" value="${listInfo.totalRows}"/>
  <input type="hidden" id="firstRow" name="firstRow" value="${listInfo.firstRow}"/>
  <input type="hidden" id="rowCount" name="rowCount" value="${rowCount}"/>
</form>

<%-- The table of results --%>
<div id="actualContents">
<c:choose>

  <c:when test="${not empty errorMessage}">
    <br><br>
    <div style="background-color:#FAF8ED;width:100%;">
      <center>
        <br>
        <i>&nbsp;&nbsp;${errorMessage}</i>
      </center>
    </div>
  </c:when>


  <c:otherwise>
      <div width="100%" style="background-color:#FAF8ED; margin-top:-2px;">
        <div class="configurationTableTitle" style="float:left;background-color:#FAF8ED;border-bottom:0px;margin-top:6px;margin-left:1px;">
           <b>&nbsp;&nbsp;${listInfo.inds}</b>
        </div>
        <div style="float:right;font-size:xx-small;margin-top:2px;">
             <c:choose>
             <c:when test="${listInfo.firstRow <= 1}">
                 <img src="images/rules/double_left_03g.gif" border="0"></span>&nbsp;&nbsp;
                 <img src="images/rules/left_03g.gif" border="0"></span>&nbsp;&nbsp;
             </c:when>
             <c:otherwise>
                 <span onclick="document.contentsForm.firstRow.value=1;document.contentsForm.submit()" title="First"><img src="images/rules/double_left_03b.gif" border="0"></span>&nbsp;&nbsp;
                 <span onclick="document.contentsForm.firstRow.value=${listInfo.firstRow-rowCount};document.contentsForm.submit()" title="Previous"><img src="images/rules/left_03b.gif" border="0"></span>&nbsp;&nbsp;
             </c:otherwise>
             </c:choose>

             <c:choose>
             <c:when test="${(listInfo.firstRow+shownCount) > listInfo.totalRows}">
                 <img src="images/rules/right_03g.gif" border="0"></span>&nbsp;&nbsp;
                 <img src="images/rules/double_right_03g.gif" border="0"></span>&nbsp;&nbsp;
             </c:when>
             <c:otherwise>
                 <span onclick="document.contentsForm.firstRow.value=${listInfo.firstRow+rowCount};document.contentsForm.submit()" title="Next"><img src="images/rules/right_03b.gif" border="0"></span>&nbsp;&nbsp;
                 <span onclick="document.contentsForm.firstRow.value=${listInfo.totalRows-rowCount+1};document.contentsForm.submit()" title="Last"><img src="images/rules/double_right_03b.gif" border="0"></span>&nbsp;&nbsp;
             </c:otherwise>
             </c:choose>
             <br>
             Rows ${listInfo.firstRow} to ${listInfo.firstRow + shownCount - 1} of ${listInfo.totalRows} &nbsp;&nbsp;
        </div>
      </div>
      <TABLE class="mainTable" align="center" width="96%" style="border-collapse:separate;border-top:1px solid #D2B48C;border-bottom:1px solid #D2B48C;border-left:1px solid #D2B48C;border-right: 1px solid #F5DEB3;background-color:white" id="contentsTable" cellspacing="0" cellpadding="5">
         <thead>
           <TR class="tableColumnHeaderRow" >
             <c:forTokens var="col" items="${listInfo.nakedColumns}" delims=" ">
               <TH class="centeredTableHeader" nowrap style="border-left:1px solid #f1eacb;">&nbsp;${col}</TH>
             </c:forTokens>
           </TR>
         </thead>
         <TBODY id="ruleTableBody">
          <c:if test="${empty listInfo.contents}">
            <TR rowspan="2">
               <TD align="right" style="font-size:8pt;border-left:1px solid #f1eacb;" colspan="100%"><center><em>No data available.</center></em></TD>
            </TR>
          </c:if>
          <c:if test="${not empty listInfo.contents}">
            <c:forEach var="row" items="${listInfo.contents}" varStatus="status">
               <%-- Not honoring color alternation in css dataRow${status.count%2+1}_tableRow, so do it by hand --%>
               <c:set var="bgcolor" value="white"/>
               <c:if test="${status.count%2==0}"><c:set var="bgcolor" value="#FAF8ED"/></c:if>
               <TR id="${status.count}" class="dataRow${status.count%2+1}_tableRow" >
                  <c:forTokens var="col" items="${listInfo.typedColumns}" delims=" ">
                     <c:set var="cls" value="textTableCell"/>
                     <c:if test="${fn:indexOf(col,'#')>=0}"><c:set var="cls" value="numericTableCell"/></c:if>
                     <TD style="background-color:${bgcolor};vertical-align:top;border-left:1px solid #f1eacb;" class="${cls}" >&nbsp;${fn:trim(fn:escapeXml(row[fn:replace(fn:replace(fn:toUpperCase(col),'$',''),'#','')]))}</TD>
                  </c:forTokens>
               </TR>
            </c:forEach>
          </c:if>
         </TBODY>
      </TABLE>


      <%-- If this file is not in the parent selection list, add it --%>
      <script>
         var indsSelector = window.parent.document.getElementById("inds");
         if (indsSelector.options)
         {
           var i;
           for (i=0; i<indsSelector.options.length;i++)
           {
             if (indsSelector.options[i].value=="${listInfo.inds}")
               break;
           }
           if (i==indsSelector.options.length)
           {
             var opt = window.parent.document.createElement("option");
             opt.value = "${listInfo.inds}";
             opt.text = "${listInfo.inds}";
             indsSelector.options[i] = opt;
             indsSelector.selectedIndex = i;
           }
         }

          	var action = '<c:url value="/r_lookupLists.do"/>';
    		try { refreshContent(action); } catch(e) { } // Ignore this

      </script>

  </c:otherwise>



</c:choose>
</div>

</BODY>
</HTML>





