<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2006, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/ruleSaveResultsContent.jsp
|DESCRIPTION: Non-visible container for the results of saving a rule
|---------------------------------------------------------------------------------------*/%>

<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<HTML>
<HEAD>
  <meta http-equiv="cache-control" content="no-cache"/>
  <TITLE>Rule Save Results</TITLE>
  <SCRIPT language='JavaScript' src='rules/scripts/ruleSasTest.js'></SCRIPT>
  <SCRIPT language="JavaScript" src="rules/scripts/mylistboxAssignments.js"></SCRIPT>
  <SCRIPT language='JavaScript' src='rules/scripts/rules.js'></SCRIPT>
</HEAD>


<BODY
    onload="showSaveComplete()"
    onunload=""
    onblur=""
    onmousemove=""
    style="background-color:white"
    marginheight="0"
    marginwidth="0">




<%-- Define mapping area for updated field-to-label, card-level transaction, and dependency possibility info --%>
<SCRIPT>
//<!--
  var preRequisiteLabelMap = new Array();
  <c:forEach var="p" items="${Possibles}"> preRequisiteLabelMap["#${p.baseRuleId}"]="<c:out value='${p.label}' escapeXml='false'/>"; </c:forEach>

  var FieldLabelMap = new Array();
  <c:forEach var="f" items="${sasEditorSelectorMaps.fieldLabelMapEscaped}">FieldLabelMap["<c:out value='${f.key}'/>"]="<c:out value='${f.value}' escapeXml='false'/>"; </c:forEach>

//-->
</SCRIPT>


<%-- Define form areas to contain the results of the save --%>
<form name="resultsForm">

  <input type="text" name="ruleId"      id="ruleId"        value="${rule.id}">
  <input type="text" name="lockVersion" id="lockVersion"   value="${rule.lockVersion}">
  <input type="text" name="version"     id="version"       value="${rule.version}">
  <input type="text" name="baseRuleId"  id="baseRuleId"    value="${rule.baseRuleId}">
  <input type="text" name="state"       id="state"         value="${rule.workflow.state}" />
  <input type="text" name="checkoutUser" id="checkoutUser" value="${fn:escapeXml(rule.checkoutUser)}" />
  <input type="text" name="slotId"      id="slotId"        value="${rule.ruleFiredSlotsByTenantMultiOrgId[rule.businessUnitItem.rootMultiOrgId].id}" />
  <input type="text" name="ruleTypeId"  id="ruleTypeId"    value="${rule.ruleType.id}" />
  <input type="text" name="multiOrgId"  id="multiOrgId"    value="${rule.multiOrgNodeId}" />
  <input type="text" name="executionOrderType"     id="executionOrderType"     value="${rule.executionOrderType}" />
  <input type="text" name="executionOrderPriority" id="executionOrderPriority" value="${rule.executionOrderPriority}" />
  <input type="text" name="nextOp"      id="nextOp"        value="${nextOp}" />
</form>




<br>
<span id="createdInfo">
  <span dateFormat="${esapi:encodeForHTML(dateFormat)} ${esapi:encodeForHTML(timeFormat)}" dateValue="${rule.createTimestampUtcMillis}"> </span>&nbsp;by ${fn:escapeXml(rule.createUser)}
</span>

<br>
<span id="updatedInfo">
  <span dateFormat="${esapi:encodeForHTML(dateFormat)} ${esapi:encodeForHTML(timeFormat)}" dateValue="${rule.lastUpdateTimestampUtcMillis}"> </span>&nbsp;by ${fn:escapeXml(rule.lastUpdateUser)}
</span>

<br>
<span id="checkoutInfo">
  <span dateFormat="${esapi:encodeForHTML(dateFormat)} ${esapi:encodeForHTML(timeFormat)}" dateValue="${rule.checkoutTimeUtcMillis}"> </span>&nbsp;by ${fn:escapeXml(rule.checkoutUser)}
</span>

<br>
<span id="baseRuleIdInfo">
  ${rule.baseRuleId}.${rule.version} (${rule.workflow.state})
</span>

<br>
<span id="ruleBusinessUnitInfo">
  ${ruleBusinessUnit}
</span>

<br>
<span id="ruleTypeInfo">
  ${rule.ruleType.name}
</span>


<br>
<span id="saveStatusDisplay">
  <c:if test="${not empty confirmationMessage}">
    <c:choose>
    <c:when test="${not empty errorMessage}">
      <span id="refreshOpenerIndicator"
            title="${esapi:encodeForHTML(errorMessage)}"
            onclick='alert("${errorMessage}")'
            style="color:red; font-weight:bold; cursor:pointer;">${esapi:encodeForHTML(confirmationMessage)}</span>
    </c:when>
    <c:otherwise>
      <span id="refreshOpenerIndicator"
            title="Operation was successful."
            onclick="alert('Operation was successful.')"
            style="color:black; font-weight:bold; cursor:pointer;">${esapi:encodeForHTML(confirmationMessage)}</span>
    </c:otherwise>
    </c:choose>
  </c:if>
</span>




</BODY>
</HTML>


