<%/*--------------------------------------------------------------------------------------|
|Copyright (c) 2005-2006, SAS Institute, Inc.  All Rights Reserved.
|
|NAME: rules/tiles/ruleEstimatesReportHeader.jsp
|DESC: JSP page to containing header lines used by multiple estimation screens
|---------------------------------------------------------------------------------------*/%>


<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
<span align="left">
<table border='0' width="97%" id="rptHeader" class="configurationTable" style="border:0px;margin-left:-5px;" cellspacing="0" cellpadding="2"  >

<tr>
   <td nowrap class="title" colspan="4" align="left"  style="background-color:#FFFFFF;font-size:x-small;">
      <b id='ALL_opener' title="Click to expand all estimation summary reports" onclick="_showEstimateReport('${estimateId}', '', 'ALL');" style="cursor:pointer;">
        Estimate ${estimate.id}&nbsp;:&nbsp;${estimate.name}&nbsp;
        <image src="images/rules/opener.gif" />
      &nbsp;&nbsp;(${fn:trim(estimate.status)})</b>
   </td>
</tr>

<c:if test="${fn:trim(estimate.status) == 'Failed'}">
 <tr><td style="font-size:.5em">&nbsp;</td></tr>
 <tr>
   <td nowrap class="configurationTableTitle" align="left" colspan="4" style="background-color:#FFFFFF;font-size:x-small;">
       <font color='red' onclick="_showSASLog(${estimate.id});" style="font-weight:bold;cursor:pointer;">There were errors in this estimation. See SAS log for details.</font>
   </td>
 </tr>
</c:if>

<tr><td style="height:.6em;"></td></tr>

<tr class="configurationTableTitle" style="font-size:medium;color:#000000;background-color:#FFFFFF;border-bottom: 0px;"> 
  <td nowrap align="left" style="font-size:x-small;width:1%;" valign="top">Requested Dates:<br>Days in Run:<br>Account Fragment:<br>Sample Size:<br>Job Ended:<br>Transactions:<br><br>Metrics:<br><br><br><br><br>
     <br>Tuning:
  </td>
  <td nowrap align="left" style="font-size:x-small;" valign="top">
    <c:choose>
      <c:when test="${estimate.rangeStartDate != null && estimate.rangeEndDate != null}">
         <span dateFormat="${dateFormat}" dateValue="${estimate.rangeStartDate.time}"> </span> &nbsp;- <span dateFormat="${dateFormat}" dateValue="${estimate.rangeEndDate.time}"> </span> &nbsp;
      </c:when>
      <c:otherwise>
         <i>Unavailable</i>
      </c:otherwise>
    </c:choose>

    <br>
    ${estimate.daysInRun}

    <br>
    <c:choose>
       <c:when test="${not empty estimate.optionsMap.Acct && estimate.optionsMap.Acct!='null'}">${estimate.optionsMap.Acct} </c:when>
       <c:otherwise><i>None</i></c:otherwise>
    </c:choose>

    <br>
    <c:choose>
       <c:when test="${not empty estimate.optionsMap.Sample}">${fn:substringBefore(estimate.optionsMap.Sample,'%')}%</c:when>
       <c:otherwise>100%</c:otherwise>
    </c:choose>

    <br>
    <c:if test="${not empty estimate.jobEndTime}">
      <span dateFormat="${dateFormat} ${timeFormat}" dateValue="${estimate.jobEndTimeUtcMillis}"> </span> &nbsp;    
    </c:if>

    <br>
    <c:choose>
      <c:when test="${estimate.transactionCount != null}">
        ${estimate.transactionCount}
      </c:when>
      <c:otherwise>0</c:otherwise>
    </c:choose>
    Read,
    
    <c:choose>
      <c:when test="${estimate.transactionFiredCount != null}">
        <a href="javascript:showDetailReport(0,${estimate.transactionFiredCount})" title="Click to view all fired detail records" style="color:blue;font-weight:bold;cursor:pointer;">${estimate.transactionFiredCount}</a>
      </c:when>
      <c:otherwise>0</c:otherwise>
    </c:choose>
    Fired,
    
    <c:choose>
      <c:when test="${transactionNoteCount != null}">
       <a href="javascript:showDetailReport('N',${transactionNoteCount})" title="Click to view all notes" style="color:blue;font-weight:bold;cursor:pointer;">${transactionNoteCount}</a>
      </c:when>
      <c:otherwise>0</c:otherwise>
    </c:choose>
    Notes,
    
    <c:choose>
      <c:when test="${transactionHighlightCount != null}">
       <a href="javascript:showDetailReport('H',${transactionHighlightCount})" title="Click to view all highlights" style="color:blue;font-weight:bold;cursor:pointer;">${transactionHighlightCount}</a>
      </c:when>
      <c:otherwise>0</c:otherwise>
    </c:choose>
    Highlights
    
    
    <br>
    <br>
    <c:set var="checked" value=""/>
    <c:if test="${not empty estimate.optionsMap.Dampen}"> <c:set var="checked" value="checked='checked'"/> </c:if>
    <input type="checkbox" ${checked} onclick="this.checked=!this.checked">
    Dampen Premature Firings

    <br>
    <c:set var="checked" value=""/>
    <c:if test="${estimate.optionsMap.NoRecon>0}"> <c:set var="checked" value="checked='checked'"/> </c:if>
    <input type="checkbox" ${checked}  onclick="this.checked=!this.checked">
    Dampen Firings within ${estimate.optionsMap.NoRecon} No-Recontact Days

    <br>
    <c:set var="checked" value=""/>
    <c:if test="${not empty estimate.optionsMap.TotalCounts}"> <c:set var="checked" value="checked='checked'"/> </c:if>
    <input type="checkbox" ${checked}  onclick="this.checked=!this.checked">
    Total All Counts (include unfired)

    <br>
    <c:set var="checked" value=""/>
    <c:if test="${not empty estimate.optionsMap.Redist}"> <c:set var="checked" value="checked='checked'"/> </c:if>
    <input type="checkbox" ${checked}  onclick="this.checked=!this.checked">
    Enable Redistribution


    <br>
    
    <br>
    <c:choose>
    <c:when test="${not empty estimate.optionsMap.Sample}">
       <input type="checkbox" checked='checked' onclick="this.checked=!this.checked"> Split Transactions by ${randDigMap[fn:substringBefore(fn:substringAfter(estimate.optionsMap.Sample,'%'),'#')]}<br>
       <c:choose>
       <c:when test="${1==fn:substringAfter(estimate.optionsMap.Sample,'/')}">
          <input type="checkbox" onclick="this.checked=!this.checked"> Use Parallel Processing with ${estimateDefaultThreadCount} Threads
       </c:when>
       <c:otherwise>
          <input type="checkbox" checked='checked' onclick="this.checked=!this.checked"> Use Parallel Processing with ${fn:substringAfter(estimate.optionsMap.Sample,'/')} Threads
       </c:otherwise>
       </c:choose>
    </c:when>
    <c:otherwise>
       <input type="checkbox" onclick="this.checked=!this.checked"> Split Transactions by ${randDigMap[defaultRandDigName]}<br>
       <input type="checkbox" onclick="this.checked=!this.checked"> Use Parallel Processing with ${estimationDefaultThreadCount} Threads
    </c:otherwise>
    </c:choose>

    <br>
    <c:set var="checked" value=""/>
    <c:if test="${not empty estimate.optionsMap.CacheVars}"> <c:set var="checked" value="checked='checked'"/> </c:if>
    <input type="checkbox" ${checked}  onclick="this.checked=!this.checked"> Cache User Variables in Memory

    <br>
    <c:set var="checked" value=""/>
    <c:if test="${not empty estimate.optionsMap.SASSort}"> <c:set var="checked" value="checked='checked'"/> </c:if>
    <input type="checkbox" ${checked}  onclick="this.checked=!this.checked"> Sort Transactions in SAS
    
  </td>
  
  <td nowrap align="right" style="font-size:x-small;" valign="top" rowspan="1">Summary:</td>

  <td nowrap align="left" style="font-size:x-small;" rowspan="1" valign="top">
    <c:forEach var="t" items="${alertTypes}">
       <c:if test="${!t.value.highlightable || true}"> <%-- Do not suppress trade types for now --%>
         <c:set var="checked" value=""/>
         <c:if test="${fn:indexOf(estimate.optionsMap.KeyTypes,t.value.code)>=0}"> <c:set var="checked" value="checked='checked'"/> </c:if>
         <input type="checkbox" ${checked} onclick="this.checked=!this.checked">
         Per ${t.value['desc']}<br>
       </c:if>         
    </c:forEach>

    <br>
    <c:set var="checked" value=""/>
    <c:if test="${not empty estimate.optionsMap.PerRule}"> <c:set var="checked" value="checked='checked'"/> </c:if>
    <input type="checkbox" ${checked} onclick="this.checked=!this.checked">
    Per Rule

    <br>
    <c:set var="checked" value=""/>
    <c:if test="${not empty estimate.optionsMap.PerFraud}"> <c:set var="checked" value="checked='checked'"/> </c:if>
    <input type="checkbox" ${checked} onclick="this.checked=!this.checked">
    Per Fraud Type

    <br>&nbsp;<br> <%-- S1065224 --%>
    <c:set var="checked" value=""/> <%-- S1065224 --%>
    <c:if test="${not empty estimate.optionsMap.ExcTest}"> <c:set var="checked" value="checked='checked'"/> </c:if> <%-- S1065224 --%>
    <input type="checkbox" ${checked}  onclick="this.checked=!this.checked"> <%-- S1065224 --%>
    Exclude Testing Rules <%-- S1065224 --%>
  </td>

</tr>

<tr><td>&nbsp;</td></tr>

</table name="rptHeader">
</span>


