update frh_alert_action_fact set 
  TRANS_BLOCK_UNTIL_ACTION=(case when length(trim(TRANS_BLOCK_UNTIL_ACTION))=0 then null else TRANS_BLOCK_UNTIL_ACTION END),
  SYS_BLOCK_2_UNTIL_ACTION=(case when length(trim(SYS_BLOCK_2_UNTIL_ACTION))=0 then null else SYS_BLOCK_2_UNTIL_ACTION END),
  SYS_BLOCK_1_UNTIL_ACTION=(case when length(trim(SYS_BLOCK_1_UNTIL_ACTION))=0 then null else SYS_BLOCK_1_UNTIL_ACTION END),
  CONTACT_WORK_PHONE_IND=(case when length(trim(CONTACT_WORK_PHONE_IND))=0 then null else CONTACT_WORK_PHONE_IND END),
  CONTACT_HOME_PHONE_IND=(case when length(trim(CONTACT_HOME_PHONE_IND))=0 then null else CONTACT_HOME_PHONE_IND END),
  CONTACT_MOBILE_PHONE_IND=(case when length(trim(CONTACT_MOBILE_PHONE_IND))=0 then null else CONTACT_MOBILE_PHONE_IND END),
  SERVICE_METHOD_CODE=(case when length(trim(SERVICE_METHOD_CODE))=0 then null else SERVICE_METHOD_CODE END)
;

update FRH_ALERT_FULFILLMNT_DIM set 
  SENT_EMAIL_IND=(case when length(trim(SENT_EMAIL_IND))=0 then null else SENT_EMAIL_IND END),
  SENT_LETTER_IND=(case when length(trim(SENT_LETTER_IND))=0 then null else SENT_LETTER_IND END),
  SENT_SMS_IND=(case when length(trim(SENT_SMS_IND))=0 then null else SENT_SMS_IND END)
;

update FRH_PROPERTY_DIM set 
  CHANGE_CURRENT_IND=(case when length(trim(CHANGE_CURRENT_IND))=0 then null else CHANGE_CURRENT_IND END)
;

update FRH_RULE_DIM set 
  CHANGE_CURRENT_IND=(case when length(trim(CHANGE_CURRENT_IND))=0 then null else CHANGE_CURRENT_IND END)
  ;

ALTER TABLE FRH_ALERT_ACTION_FACT ADD 
  CONSTRAINT CK_ALERT_ACTION_FACT1
  CHECK (TRANS_BLOCK_UNTIL_ACTION IN ('AD', 'RM', 'NC'))
  ENABLE QUERY OPTIMIZATION
  ADD CONSTRAINT CK_ALERT_ACTION_FACT2
  CHECK (SYS_BLOCK_2_UNTIL_ACTION IN ('AD', 'RM', 'NC'))
  ENABLE QUERY OPTIMIZATION
  ADD CONSTRAINT CK_ALERT_ACTION_FACT3
  CHECK (SYS_BLOCK_1_UNTIL_ACTION IN ('AD', 'RM', 'NC'))
  ENABLE QUERY OPTIMIZATION
  ADD CONSTRAINT CK_ALERT_ACTION_FACT4
  CHECK (CONTACT_WORK_PHONE_IND IN ('0', '1'))
  ENABLE QUERY OPTIMIZATION
  ADD CONSTRAINT CK_ALERT_ACTION_FACT5
  CHECK (CONTACT_HOME_PHONE_IND IN ('0', '1'))
  ENABLE QUERY OPTIMIZATION
  ADD  CONSTRAINT CK_ALERT_ACTION_FACT6
  CHECK (CONTACT_MOBILE_PHONE_IND IN ('0', '1'))
  ENABLE QUERY OPTIMIZATION
  ADD CONSTRAINT CK_ALERT_ACTION_FACT7
  CHECK (SERVICE_METHOD_CODE IN ('INB', 'OUT', 'EML', 'LTR', 'AUT', 'SMS'))
  ENABLE QUERY OPTIMIZATION
;

ALTER TABLE FRH_ALERT_FULFILLMNT_DIM ADD 
  CONSTRAINT CK_ALERT_FULFILLMNT_DIM1
  CHECK (SENT_EMAIL_IND IN ('0', '1'))
  ENABLE QUERY OPTIMIZATION
  ADD CONSTRAINT CK_ALERT_FULFILLMNT_DIM2
  CHECK (SENT_LETTER_IND IN ('0', '1'))
  ENABLE QUERY OPTIMIZATION
  ADD CONSTRAINT CK_ALERT_FULFILLMNT_DIM3
  CHECK (SENT_SMS_IND IN ('0', '1'))
  ENABLE QUERY OPTIMIZATION
;


  ALTER TABLE FRH_PROPERTY_DIM ADD 
  CONSTRAINT CK_PROPERTY_DIM2
  CHECK (CHANGE_CURRENT_IND IN ('0', '1'))
  ENABLE QUERY OPTIMIZATION
;

ALTER TABLE FRH_RULE_DIM
  ADD CONSTRAINT CK_RULE_DIM1 CHECK
    (CHANGE_CURRENT_IND IN ('0', '1'))
    ENFORCED
    ENABLE QUERY OPTIMIZATION;