---------------------------------------------------------------------------------
--
-- Metadata Updates for version release 3.3.1.1 (3.3 M1 HF1)
--
---------------------------------------------------------------------------------
UPDATE FCM_SEGMENT_DEFINITION SET 
	TENANT_MULTI_ORG_ID = null
WHERE SEGMENT_ACRONYM in ('V00','V01','V02','V03','V04','V05','V06','V07');

update FCM_ALERT_TYPE SET HIGHLIGHTABLE_IND = '1' where ALERT_TYPE = 'T';

--
-- Update Transaction table names that were renamed
--
UPDATE FCM_GRID_TRANS_ACTIVITY set SOR_TABLE_NAME='FCM_SLCP' where SOR_TABLE_NAME='FCM_SLAP';
UPDATE FCM_GRID_TRANS_ACTIVITY set SOR_TABLE_NAME='FCM_SLCK' where SOR_TABLE_NAME='FCM_SLAC';

--
-- Add new API fields to the XAMS Grid Templates for selection in the grids
--
MERGE INTO FCM_GRID_TMPLT_FIELD_CFG ar
  USING (SELECT  DISTINCT  gt.GRID_TEMPLATE_ID, ga.ACCOUNT_TYPE_ID, gta.TRANS_ACTIVITY_ID, fd.FIELD_ID as GRID_FIELD_ID,
                fd.XML_FIELD_NAME as GRID_FIELD_HEADER, fd.FIELD_DESC_EDIT as GRID_FIELD_HEADER_DESC,
                 fd.DATA_POP_ENABLED_IND as DATA_POP_ENABLED_IND
        FROM    FCM_FIELD_DEFINITION AS fd, FCM_SEGMENT_DEFINITION sd, FCM_COMPONENT_SEGMENT AS CompSegment, FCM_COMPONENT_VALUE AS CompValue,
                FCM_TRANSACTION_COMPONENT AS TransComp, FCM_GRID_TRANS_ACTIVITY AS gta, FCM_GRID_ACCOUNT AS ga, FCM_GRID_TMPLT AS gt
        WHERE   FD.FIELD_VISIBLE_IND = '1' 
                AND fd.SEGMENT_ID = sd.SEGMENT_ID 
                AND sd.SEGMENT_ID = CompSegment.SEGMENT_ID 
                AND CompSegment.COMPONENT_VALUE_ID = CompValue.COMPONENT_VALUE_ID 
                AND CompValue.COMPONENT_VALUE_ID = TransComp.COMPONENT_VALUE_ID 
                AND TransComp.TRANSACTION_ID = GTA.TRANS_ACTIVITY_ID 
                AND ga.ACCOUNT_TYPE_VALUE = SUBSTR(gta.TRANS_ACTIVITY_ACRONYM, 1,2)                             
                AND FD.FIELD_ID > -1 
                AND grid_template_type = 'XAMS'
                AND sd.segment_acronym not in ('CQF' ,'ZMD') ) ac
                --and sd.segment_acronym != 'ZMD') ac         
  ON (ar.GRID_TEMPLATE_ID = ac.GRID_TEMPLATE_ID
      AND ar.ACCOUNT_TYPE_ID = ac.ACCOUNT_TYPE_ID
      AND ar.TRANS_ACTIVITY_ID = ac.TRANS_ACTIVITY_ID
      AND ar.GRID_FIELD_ID = ac.GRID_FIELD_ID
      )
   WHEN NOT MATCHED THEN
        INSERT  (GRID_TEMPLATE_ID, ACCOUNT_TYPE_ID, TRANS_ACTIVITY_ID, GRID_FIELD_ID, FIELD_ORDER, FIELD_SELECTED_IND, GRID_FIELD_HEADER,
                GRID_FIELD_HEADER_DESC, FIELD_ALIGNMENT, DATA_POP_ENABLED_IND, ALL_TAB_ENABLED_IND, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER,
                LSTUPDT_TIMESTAMP, LSTUPDT_NBR)       
        VALUES (ac.GRID_TEMPLATE_ID, ac.ACCOUNT_TYPE_ID, ac.TRANS_ACTIVITY_ID, ac.GRID_FIELD_ID, 0, '0', ac.GRID_FIELD_HEADER,
                ac.GRID_FIELD_HEADER_DESC, 'Left', ac.DATA_POP_ENABLED_IND, '0', CURRENT USER, CURRENT TIMESTAMP - CURRENT TIMEZONE
                , CURRENT USER, CURRENT TIMESTAMP - CURRENT TIMEZONE, 0)
                ;

--
-- Add new API fields to NON - XAMS Grid Templates for selection in the grids
--
MERGE INTO FCM_GRID_TMPLT_FIELD_CFG ar
  USING (SELECT  DISTINCT  gt.GRID_TEMPLATE_ID, ga.ACCOUNT_TYPE_ID, gta.TRANS_ACTIVITY_ID, fd.FIELD_ID as GRID_FIELD_ID,
                fd.XML_FIELD_NAME as GRID_FIELD_HEADER, fd.FIELD_DESC_EDIT as GRID_FIELD_HEADER_DESC,
                 fd.DATA_POP_ENABLED_IND as DATA_POP_ENABLED_IND
        FROM    FCM_FIELD_DEFINITION AS fd, FCM_SEGMENT_DEFINITION sd, FCM_COMPONENT_SEGMENT AS CompSegment, FCM_COMPONENT_VALUE AS CompValue,
                FCM_TRANSACTION_COMPONENT AS TransComp, FCM_GRID_TRANS_ACTIVITY AS gta, FCM_GRID_ACCOUNT AS ga, FCM_GRID_TMPLT AS gt
        WHERE   FD.FIELD_VISIBLE_IND = '1' 
                AND fd.SEGMENT_ID = sd.SEGMENT_ID 
                AND sd.SEGMENT_ID = CompSegment.SEGMENT_ID 
                AND CompSegment.COMPONENT_VALUE_ID = CompValue.COMPONENT_VALUE_ID 
                AND CompValue.COMPONENT_VALUE_ID = TransComp.COMPONENT_VALUE_ID 
                AND TransComp.TRANSACTION_ID = GTA.TRANS_ACTIVITY_ID 
                AND ga.ACCOUNT_TYPE_VALUE = SUBSTR(gta.TRANS_ACTIVITY_ACRONYM, 1,2)                             
                AND FD.FIELD_ID > -1                
                AND grid_template_type != 'XAMS'
                AND sd.segment_acronym not in ('ZMD') ) ac                
  ON (ar.GRID_TEMPLATE_ID = ac.GRID_TEMPLATE_ID
      AND ar.ACCOUNT_TYPE_ID = ac.ACCOUNT_TYPE_ID
      AND ar.TRANS_ACTIVITY_ID = ac.TRANS_ACTIVITY_ID
      AND ar.GRID_FIELD_ID = ac.GRID_FIELD_ID
      )
   WHEN NOT MATCHED THEN
        INSERT  (GRID_TEMPLATE_ID, ACCOUNT_TYPE_ID, TRANS_ACTIVITY_ID, GRID_FIELD_ID, FIELD_ORDER, FIELD_SELECTED_IND, GRID_FIELD_HEADER,
                GRID_FIELD_HEADER_DESC, FIELD_ALIGNMENT, DATA_POP_ENABLED_IND, ALL_TAB_ENABLED_IND, CREATE_USER, CREATE_TIMESTAMP, LSTUPDT_USER,
                LSTUPDT_TIMESTAMP, LSTUPDT_NBR)       
        VALUES (ac.GRID_TEMPLATE_ID, ac.ACCOUNT_TYPE_ID, ac.TRANS_ACTIVITY_ID, ac.GRID_FIELD_ID, 0, '0', ac.GRID_FIELD_HEADER,
                ac.GRID_FIELD_HEADER_DESC, 'Left', ac.DATA_POP_ENABLED_IND, '0', CURRENT USER, CURRENT TIMESTAMP - CURRENT TIMEZONE
                , CURRENT USER, CURRENT TIMESTAMP - CURRENT TIMEZONE, 0)
                ;
        


---------------------------------------------------------------------------------
--
-- Remove "Deploy Rules" privilege from the Console Admin role
--
---------------------------------------------------------------------------------

DELETE FROM FCM_ROLE_PRIVILEGE WHERE
ROLE_ID IN (SELECT ROLE_ID FROM FCM_ROLE WHERE ROLE_NAME ='Console Administrator')
AND PRIVILEGE_ID IN (SELECT PRIVILEGE_ID FROM FCM_PRIVILEGE WHERE SYSTEM_PRIVILEGE_NAME='DEPLRULE');



---------------------------------------------------------------------------------
--
-- Insert version release 3.3.1.1 (3.3 M1 HF1)
--
---------------------------------------------------------------------------------

insert into fcm_version(VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) VALUES
('Base DDL', '3.3.1.1', current date, '3.3 M1 HF1 DDL', 'DDL');