create type sasfm_array
    as table of number
/
CREATE OR REPLACE FUNCTION GET_RULE_SLOTS (I_BITS VARchar2 )
  RETURN sasfm_array PIPELINED AS
  
  
-----------------------------------------------------------------------------
-- File:  GET_RULE_SLOTS
--
--
-- Description:  Decodes the RRF rule bit array
--
--
-- Called By:    webapp
--
--
-- Calls:
--
--
-- Notes:
--
--
-- Usage:
--
--
-- History:    2013/09/23:  Creation date
--
------------------------------------------------------------------------
  
  ii INTEGER := 0;
  chr_no integer :=0;
  ch char(1);
  l_start INTEGER := 0;
  l_size INTEGER;
  
BEGIN 
   l_size := length(i_bits);
    
  while(ii < l_size) LOOP
      ch := substr(upper(i_bits),ii+1,1);
     if(ch != '0') then 
          chr_no:=ascii(ch);
          
          l_start := (ii * 4)+1;
          
         if(bitand(chr_no,8)=8) then
             pipe row(l_start);
         end if;
         if(bitand(chr_no,4)=4) then
             pipe row(l_start+1);
         end if;
         if(bitand(chr_no,2)=2) then
             pipe row(l_start+2);
         end if;
         if(bitand(chr_no,1)=1) then
             pipe row(l_start+3);
         end if;

     end if;
      ii := ii + 1;
  end loop;

  RETURN ;

END GET_RULE_SLOTS;
/

Show errors;

