---------------------------------------------------------------------------------
--
-- Always make the VIEWGROUP and UPDTGROUP "ON" regardless if SAMS or XAMS
--
---------------------------------------------------------------------------------
UPDATE FCM_PRIVILEGE
SET LOGICAL_DEL_IND = 0
,LSTUPDT_USER=USER
,LSTUPDT_TIMESTAMP= CURRENT_TIMESTAMP
,LSTUPDT_NBR=LSTUPDT_NBR+1
WHERE SYSTEM_PRIVILEGE_NAME in ('VIEWGROUP', 'UPDTGROUP');
commit;

---------------------------------------------------------------------------------
--
-- If XAMS Configuration, set the XAMS Grids as NOT LOGICALLY DELETED.
-- If SAMS Configuration, the update will update Zero rows.
--
---------------------------------------------------------------------------------
UPDATE FCM_GRID_TMPLT 
SET LOGICAL_DEL_IND = 0
,LSTUPDT_USER=USER
,LSTUPDT_TIMESTAMP= CURRENT_TIMESTAMP
,LSTUPDT_NBR=LSTUPDT_NBR+1
WHERE
GRID_TEMPLATE_TYPE='XAMS'
AND exists(select PROPERTY_VALUE FROM FCM_PROPERTY where upper(property_name)=upper('webapp.enableXAMS') and upper(property_value)='TRUE');
commit;

---------------------------------------------------------------------------------
--
-- Insert version release 3.3.1.5 (3.3 M1 HF5)
--
---------------------------------------------------------------------------------
insert into fcm_version(VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) VALUES
('Base DDL', '3.3.1.5', current_date, '3.3 M1 HF5 DDL', 'DDL') ;
commit;